<?php
/*
Plugin Name: j-yak
Plugin URI: http://wppluginsj.sourceforge.jp/j-yak/
Description: A simple shopping cart for WordPress
Version: 0.7aj
Author: Otsukare
Author URI: http://cafelog.net/
Original: JASON R BRIGGS
	(http://www.bluebear.co.nz/log/products/yak-for-wordpress/)
	(email : jrbriggs 'at' bluebear.co.nz)
*/

/*  Copyright 2006  JASON R BRIGGS  (email : jrbriggs 'at' bluebear.co.nz)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require_once(ABSPATH . 'wp-admin/upgrade-functions.php');
require_once(ABSPATH . 'wp-includes/pluggable-functions.php');
require_once(ABSPATH . 'wp-content/plugins/j-yak/yak_payments.php');
require_once(ABSPATH . 'wp-content/plugins/j-yak/yak_model.php');

load_plugin_textdomain('yak', 'wp-content/plugins/j-yak');

global $table_prefix, $wpdb;

$order_table = $table_prefix . "yak_order";
$order_detail_table = $table_prefix . "yak_order_detail";
$order_log_table = $table_prefix . "yak_order_log";
$order_dl_table = $table_prefix . "yak_order_dl";
$buynow_error_message = '';


/**
 * CONSTANTS (DO NOT CHANGE)
 */
define("YAK_OPTIONS", "yak_options");
define("QUANTITY_INPUT_SIZE", "yak_quantity_input_size");
define("INCLUDE_SHIPPING_COSTS", "yak_include_shipping_costs");
define("CURRENCY_SYMBOL", "yak_currency_symbol");
define("MONEY_FORMAT", "yak_money_format");
define("CURRENCY_FORMAT", "yak_currency_format");
define("SHOW_OUT_OF_STOCK_MSG", "yak_show_out_of_stock");
define("CONFIRMATION_EMAIL_ADDRESS", "yak_confirmation_email");
define("CONFIRMATION_MESSAGE", "yak_confirmation_message");
define("COOKIE_LIFETIME", "yak_cookie_lifetime");
define("REDIRECT_ON_BUY_TO", "yak_redirect_on_buy");
define("AUTO_DISCOUNT", "yak_auto_discount");
define("PRICE_ROUNDING", "yak_price_rounding");
define("PAYMENT_OPTIONS", "yak_payment_options");
define("DEFAULT_COUNTRY", "yak_default_country");
define("DEFAULT_SHIPPING", "yak_default_shipping");
define("SHIPPING_NOTES", "yak_shipping_notes");
define("REQUIRE_PHONE_NUMBER", "yak_require_phone");

define("AUTO_SET_PRICE", "yak_auto_set_price");
define("AUTO_SET_QUANTITY", "yak_auto_set_quantity");
define("AUTO_SET_TITLE", "yak_auto_set_title");

define("DOWNLOAD_EMAIL", "yak_download_email");
define("DOWNLOAD_EMAIL_ADDRESS", "yak_download_email_address");
define("DOWNLOAD_URI", "yak_download_uri");
define("DOWNLOAD_FILE", "yak_download_file");

define("PAYPAL_ACCOUNT", "yak_paypal_account");
define("PAYPAL_RETURN_URL", "yak_paypal_return_url");
define("PAYPAL_CANCEL_RETURN_URL", "yak_paypal_cancel_return_url");
define("PAYPAL_IDENTITY_TOKEN", "yak_paypal_identity_token");
define("PAYPAL_CURRENCY_CODE", "yak_paypal_currency_code");

/**
 * image locations
 */
// the location of images
define("ADD_TO_CART_BUTTON_IMAGE", get_bloginfo('wpurl') . "/wp-content/plugins/j-yak/images/addtocartbutton.gif");
//define("ADD_TO_CART_BUTTON_IMAGE", get_bloginfo('wpurl') . "/wp-content/plugins/j-yak/images/basket.gif");
define("UPDATE_BUTTON_IMAGE", get_bloginfo('wpurl') . "/wp-content/plugins/j-yak/images/updatebutton.gif");
define("BUY_BUTTON_IMAGE", get_bloginfo('wpurl') . "/wp-content/plugins/j-yak/images/buybutton.gif");
define("USE_ADDRESS_BUTTON_IMAGE", get_bloginfo('wpurl') . "/wp-content/plugins/j-yak/images/useaddress.gif");
define("CONFIRM_ORDER_BUTTON_IMAGE", get_bloginfo('wpurl') . "/wp-content/plugins/j-yak/images/confirmorderbutton.gif");

/**
 * functions for payment options
 */
$payment_options = array();
$payment_options["Deposit"] = 'yak_redirect_deposit';
$payment_options["Cheque"] = 'yak_redirect_cheque';
$payment_options["PayPal"] = 'yak_redirect_paypal';

$payment_url_examples = array();
$payment_url_examples['Deposit'] = '?page_id=17';
$payment_url_examples['Cheque'] = '?page_id=18';
$payment_url_examples['PayPal'] = 'https://www.sandbox.paypal.com/cgi-bin/webscr';


/**
 * required address fields
 */
$required_address_fields = array();
$required_address_fields["recipientname"] = __('a recipient name is required', 'yak');
$required_address_fields["email"] = __('an email address is required', 'yak');
if (yak_get_option(REQUIRE_PHONE_NUMBER, "off") == 'on') {
$required_address_fields["phone"] = __('phone is required', 'yak');    
}
$required_address_fields["addr1"] = __('address line 1 is required', 'yak');
$required_address_fields["city"] = __('city is required', 'yak');
$required_address_fields["postcode"] = __('postcode is required', 'yak');


/**
 * global variables
 */
global $order_table, $order_detail_table, $order_log_table, $payment_options;

/**
 * install tables if needed
 */
yak_install();   


/**
 * kick off a session.  I wish I could find a better way of doing this.  The session should only be started once the shopping
 * process has begun -- but I can't find a way to do this within the confines of WP+PHP.
 */
session_start();



/**
 * add a custom field if it doesn't already exist, otherwise update
 */
function yak_add_meta($post_id, $name, $value) {
    $curr = get_post_meta($post_id, $name, true);
    
    if (yak_empty($curr)) {
        add_post_meta($post_id, $name, $value);   
    }
    else {
        update_post_meta($post_id, $name, $value);   
    }
}


/**
 * used by the admin panel hook
 */
function yak_admin() {    
    if (function_exists('add_management_page')) {
        add_management_page(__('yak orders', 'yak'), __('yak orders', 'yak'), 7, 'yak_view_orders', 'yak_admin_orders');
        add_management_page(__('yak products', 'yak'), __('yak products', 'yak'), 7, 'yak_view_products', 'yak_admin_products');
    }
    
    if (function_exists('add_options_page')) {
        add_options_page(__('j-yak', 'yak'), __('j-yak', 'yak'), 7, basename(__FILE__), 'yak_admin_options');
    }
}


function yak_admin_options() {
    global $payment_options, $countries;
    
    if (isset($_POST['options_update'])) {
        $options = array();
        $options[QUANTITY_INPUT_SIZE] = $_POST[QUANTITY_INPUT_SIZE];
        $options[INCLUDE_SHIPPING_COSTS] = $_POST[INCLUDE_SHIPPING_COSTS];
        $options[CURRENCY_SYMBOL] = $_POST[CURRENCY_SYMBOL];
        $options[MONEY_FORMAT] = $_POST[MONEY_FORMAT];
        $options[CURRENCY_FORMAT] = $_POST[CURRENCY_FORMAT];
        $options[DEFAULT_COUNTRY] = $_POST[DEFAULT_COUNTRY];
        $options[SHOW_OUT_OF_STOCK_MSG] = $_POST[SHOW_OUT_OF_STOCK_MSG];
        $options[CONFIRMATION_EMAIL_ADDRESS] = $_POST[CONFIRMATION_EMAIL_ADDRESS];
        $options[CONFIRMATION_MESSAGE] = $_POST[CONFIRMATION_MESSAGE];
        $options[COOKIE_LIFETIME] = $_POST[COOKIE_LIFETIME] * 24 * 60 * 60;
        $options[REDIRECT_ON_BUY_TO] = $_POST[REDIRECT_ON_BUY_TO];
        $options[AUTO_DISCOUNT] = $_POST[AUTO_DISCOUNT];
        $options[PRICE_ROUNDING] = $_POST[PRICE_ROUNDING];
        $options[REQUIRE_PHONE_NUMBER] = $_POST[REQUIRE_PHONE_NUMBER];
        
        $options[AUTO_SET_PRICE] = $_POST[AUTO_SET_PRICE];
        $options[AUTO_SET_QUANTITY] = $_POST[AUTO_SET_QUANTITY];

        $options[DOWNLOAD_URI] = $_POST[DOWNLOAD_URI];
        $options[DOWNLOAD_EMAIL] = $_POST[DOWNLOAD_EMAIL];
        $options[DOWNLOAD_EMAIL_ADDRESS] = $_POST[DOWNLOAD_EMAIL_ADDRESS];
        
        $selected_payments = array();
        foreach ($payment_options as $key=>$value) {
            $val = $_POST[$value . '_url'];
            $options[$value . '_url'] = $val;
            
            if (isset($val) && $val != '') {
                $selected_payments[] = $value;   
            }
        }
        $options[PAYMENT_OPTIONS] = $selected_payments;

        $options[PAYPAL_ACCOUNT] = $_POST[PAYPAL_ACCOUNT];
        $options[PAYPAL_RETURN_URL] = $_POST[PAYPAL_RETURN_URL];
        $options[PAYPAL_CANCEL_RETURN_URL] = $_POST[PAYPAL_CANCEL_RETURN_URL];
        $options[PAYPAL_IDENTITY_TOKEN] = $_POST[PAYPAL_IDENTITY_TOKEN];
		$options[PAYPAL_CURRENCY_CODE] = $_POST[PAYPAL_CURRENCY_CODE];
        
        $options[DEFAULT_SHIPPING] = $_POST[DEFAULT_SHIPPING];
        $options[SHIPPING_NOTES] = $_POST[SHIPPING_NOTES];
        
        foreach ($countries as $country=>$ignore) {
            $key = 'yak_' . str_replace(' ', '_', $country) . '_shipping';
            $options[$key] = $_POST[$key];
        }
        
        update_option(YAK_OPTIONS, $options);
    }
    
    $options = get_option(YAK_OPTIONS);
    global $model;
    $model[QUANTITY_INPUT_SIZE] = yak_default($options[QUANTITY_INPUT_SIZE], '3');
    $model[INCLUDE_SHIPPING_COSTS] = yak_default($options[INCLUDE_SHIPPING_COSTS], 'yes');
    $model[CURRENCY_SYMBOL] = yak_default($options[CURRENCY_SYMBOL], __('baht', 'yak'));
    $model[MONEY_FORMAT] = yak_default($options[MONEY_FORMAT], '%d');
    $model[CURRENCY_FORMAT] = yak_default($options[CURRENCY_FORMAT], '%1$s %2$s');
    $model[DEFAULT_COUNTRY] = yak_default($options[DEFAULT_COUNTRY], 'Japan');
    $model[SHOW_OUT_OF_STOCK_MSG] = yak_default($options[SHOW_OUT_OF_STOCK_MSG], 'yes');
    $model[CONFIRMATION_EMAIL_ADDRESS] = yak_default($options[CONFIRMATION_EMAIL_ADDRESS], '');
    $model[CONFIRMATION_MESSAGE] = yak_default($options[CONFIRMATION_MESSAGE], '');
    $model[COOKIE_LIFETIME] = yak_default($options[COOKIE_LIFETIME], '2592000') / (24*60*60);
    $model[REDIRECT_ON_BUY_TO] = yak_default($options[REDIRECT_ON_BUY_TO], '');
    $model[AUTO_DISCOUNT] = yak_default($options[AUTO_DISCOUNT], '0.9');
    $model[PRICE_ROUNDING] = yak_default($options[PRICE_ROUNDING], '0');
    $model[REQUIRE_PHONE_NUMBER] = yak_default($options[REQUIRE_PHONE_NUMBER], 'off');
    
    $model[AUTO_SET_PRICE] = yak_default($options[AUTO_SET_PRICE], '');
    $model[AUTO_SET_QUANTITY] = yak_default($options[AUTO_SET_QUANTITY], '');
    
    $model[DOWNLOAD_EMAIL] = yak_default($options[DOWNLOAD_EMAIL], '');
    $model[DOWNLOAD_EMAIL_ADDRESS] = yak_default($options[DOWNLOAD_EMAIL_ADDRESS], '');
    $model[DOWNLOAD_URI] = yak_default($options[DOWNLOAD_URI], '');
    
    foreach ($payment_options as $key=>$value) {
        $model[$value . '_url'] = yak_default($options[$value . '_url'], '');
    }

    $model[PAYPAL_ACCOUNT] = yak_default($options[PAYPAL_ACCOUNT], '');
    $model[PAYPAL_RETURN_URL] = yak_default($options[PAYPAL_RETURN_URL], '');
    $model[PAYPAL_CANCEL_RETURN_URL] = yak_default($options[PAYPAL_CANCEL_RETURN_URL], '');
    $model[PAYPAL_IDENTITY_TOKEN] = yak_default($options[PAYPAL_IDENTITY_TOKEN], '');
	$model[PAYPAL_CURRENCY_CODE] = yak_default($options[PAYPAL_CURRENCY_CODE], '');
    
    $model[DEFAULT_SHIPPING] = yak_default($options[DEFAULT_SHIPPING], '');
    $model[SHIPPING_NOTES] = yak_default($options[SHIPPING_NOTES], '');
    foreach ($countries as $country=>$ignore) {
        $key = 'yak_' . str_replace(' ', '_', $country) . '_shipping';
        $model[$key] = yak_default($options[$key], '');
    }
    
    include 'yak_view_options.php';
}


/**
 * display the orders-admin panel for this plugin - and update orders accordingly when an admin makes changes
 */
function yak_admin_orders() {
    global $wpdb, $order_table, $order_detail_table;
        
    // do the update of order details
    if (isset($_POST['orders_update'])) {
        for ($i = 0; $i < count($_POST['id']); $i++) {            
            $id = $_POST['id'][$i];
            $funds = $_POST['funds_received'][$i];
            $stock = $_POST['stock_sent'][$i];
            
            $wpdb->query("update $order_table set funds_received = $funds, stock_sent = $stock where id = $id");
            
            yak_check_order($id);
        }
    }

    $results = $wpdb->get_results("select o.id, o.time, o.address, o.payment_type, o.funds_received, o.shipping_cost, sum(od.price * od.quantity) as total from $order_table o, $order_detail_table od where stock_sent = 0 and o.id = od.id group by o.id");
    
    $orders = array();
    if ($results) {
        foreach ($results as $result) {
            $order = new Order($result->id, $result->time, $result->address, $result->payment_type, $result->funds_received, $result->shipping_cost, $result->total);
            
            $order->items = $wpdb->get_results("select itemname, price, quantity, (price * quantity) as total from $order_detail_table where id = " . $result->id);
            
            $orders[] = $order;
        }
    }
    
    global $model;
    $model['orders'] = $orders;
    
    include 'yak_view_orders.php';
}


/**
 * display the products-admin panel for this plugin - and update products accordingly when an admin makes changes
 */
function yak_admin_products() {
    // do the update of product details
    if (isset($_POST['products_update'])) {
        for ($i = 0; $i < count($_POST['id']); $i++) {            
            $id = $_POST['id'][$i];
            $title = $_POST['title'][$i];
            $price = $_POST['price'][$i];
            $quantity = $_POST['quantity'][$i];
            $old_quantity = $_POST['oldquantity'][$i];
            $dl_file = $_POST['dl_file'][$i];
            
            // has quantity changed in the meantime?  if so, we need to alter the new quantity
            // accordingly, otherwise it may show less stock than you have
            $current_quantity = get_post_meta($id, 'yak_quantity', true);
            $diff = $old_quantity - $current_quantity;
            $quantity = $quantity - $diff;
            if ($quantity < 0) {
                $quantity = 0;   
            }
            
            if ($title != '') {
                yak_add_meta($id, 'yak_title', "$title");
            }
            else {
                delete_post_meta($id, 'yak_title');   
            }
            
            if ($dl_file != '') {
                yak_add_meta($id, 'yak_download_file', $dl_file);   
            }
            else {
                delete_post_meta($id, 'yak_download_file');
            }
            
            update_post_meta($id, 'yak_quantity', "$quantity");
            update_post_meta($id, 'yak_price', "$price");
        }
    }
    
    // retrieve the list of products and load into the model
    $ar = get_posts('showposts=-1&order=post_title&order=DESC&numberposts=-1');
    
    $products = array();
    foreach ($ar as $post) {
        $price = get_post_meta($post->ID, 'yak_price', true);
        if (yak_empty($price)) {
            continue;
        }
        
        $title = get_post_meta($post->ID, 'yak_title', true);
        $dl_file = get_post_meta($post->ID, 'yak_download_file', true);
        
        syslog(LOG_INFO, '>>>>>>>>>>>>>>> DL FILE ' . $dl_file);
        
        $quantity = get_post_meta($post->ID, 'yak_quantity', true);
        $product = new Product($post->ID, $post->post_title, $title, $price, $quantity, $dl_file);
        
        $products[] = $product;
    }
    
    global $model;
    $model['products'] = $products;
    
    include 'yak_view_products.php';
}


/**
 * insert a "BUY" button in the post
 */
function yak_buybutton() {
    yak_buybutton_begin();
    yak_buybutton_content();
    yak_buybutton_end();
}


function yak_buybutton_begin() {
    echo '<form name="buynow" action="' . $_SERVER[PHP_SELF] . '#buynow_button" method="post">';
}


function yak_buybutton_content() {
    global $post, $wp_query, $yak_post, $buynow_error_message;
    
    // yak_post can be used to override `the_loop` post
    if (isset($yak_post)) {
        $productpost = $yak_post;
    }
    else {
        $productpost = $post;   
    }
    
    // data we'll use for submitting the form (do we redirect to another page,
    // or direct back to this page or post?)
    $redirect = yak_get_option(REDIRECT_ON_BUY_TO, '');
    if ($redirect != '') {
        $param_name = 'page_id';
        $id = $redirect;
    }
    else if (!$wp_query->is_page) {
        $param_name = 'p';
        $id = $post->ID;
    }
    else {
        $param_name = 'page_id';
        $id = $post->ID;
    }
    
    // the product being bought is either a post, or a page
    if ($productpost->post_status != 'STATIC') {
        $productpost_param_name = 'p';
    }
    else {
        $productpost_param_name = 'page_id';   
    }
    
    
    // if price isn't set then don't bother displaying the button, nor the out of stock
    // message -- this is so you can add all the functions in your post but have nothing
    // displayed until you set the yak_* fields
    $price = get_post_meta($productpost->ID, 'yak_price', true);
    if (yak_empty($price)) {
        return;   
    }
    
    // get, and check, the quantity
    $quantity = get_post_meta($productpost->ID, 'yak_quantity', true);
    $qty_is_null = false;
    if (!is_null($quantity) && $quantity != '') {
        $quantity = 0 + $quantity;
    }
    else {
        $quantity = 0;
        $qty_is_null = true;
    }
    
    // if we have product available, add the buy button
    if ($quantity > 0) {
        $rtn = '<a name="buynow_button" /><input type="hidden" name="buynow" value="' . $productpost->ID . '" /><input type="hidden" name="buynow_param" value="' . $productpost_param_name . '" /><input type="hidden" name="' . $param_name . '" value="' . $id .'" /><input type="image" src="' . ADD_TO_CART_BUTTON_IMAGE . '" />';
    }
    else if (yak_get_option(SHOW_OUT_OF_STOCK_MSG, 'no') == 'yes' && !$qty_is_null) {
        $rtn = '(' . __('Currently out of online stock', 'yak') . ')';   
    }
    
    echo $rtn . "\n";
    
    // were there any messages when the button was pressed (set in yak_init)?
    if (isset($buynow_error_message) && $buynow_error_message != '') {
        echo $buynow_error_message;   
    }
}


function yak_buybutton_end() {
    echo '</form>';
}


/**
 * calculate price of a product taking into account any automatic discount
 */
function yak_calc_price($id) {
    $auto_discount = yak_get_option(AUTO_DISCOUNT, 1);
    $price_rounding = yak_get_option(PRICE_ROUNDING, 0);
    return round(0.0 + (get_post_meta($id, 'yak_price', true) * $auto_discount), $price_rounding);
}


/**
 * display the checkout pages
 */
function yak_checkout() {
    global $post, $wp_query;
    
    if (!$wp_query->is_page) {
        $param_name = 'p';
    }
    else {
        $param_name = 'page_id';   
    }
    
    $items = $_SESSION['items'];
    
    $action = $_POST['action'];
    
    if ($action == 'update' || $action == 'address') {
        
        foreach ($items as $key => $item) {
            $itemkey = 'item_' . $key;
            $_POST[$itemkey] = round($_POST[$itemkey]);
             
            if (!isset($_POST[$itemkey]) || empty($_POST[$itemkey]) || $_POST[$itemkey] == 0) {
                $items[$key] = NULL;
                unset($items[$key]);
                
            }
            else {
                $items[$key]->quantity = $_POST[$itemkey];

            }
        }
    }

    $_SESSION['items'] = $items;
    
    if (!isset($_SESSION['items']) || yak_count_items($items) < 1) {
        echo '<p>' . __('You have no items in your shopping basket', 'yak') . '</p>';
        return;
    }

    if ($action == 'update' || yak_empty($action)) {
        $action = 'cart';
    }
    
    global $model;
    $model = array('items' => $items, 'param_name' => $param_name, 'post_id' => $post->ID);
    
    if ($action == 'address' && isset($_COOKIE['shipping_address']) && !empty($_COOKIE['shipping_address'])) {
        $model['shipping_address'] = unserialize(stripslashes($_COOKIE['shipping_address']));
    }
    
    if ($action == 'confirm') {
        $errors = yak_validate_address();
        
        if (count($errors) > 0) {
            $model['error_message'] = '<p>' . __('Errors have occurred validating the address information you provided', 'yak') . ':</p><ul>';
            
            foreach ($errors as $err) {
                $model['error_message'] = $model['error_message'] . '<li>' . $err . '</li>'; 
            }
            
            $model['error_message'] = $model['error_message'] . '</ul>';
            
            $action = 'address';
        }
        else {
            $model['shipping_address'] = $_POST['recipientname'] . '
' . $_POST['phone'] . '
' . $_POST['addr1'] . '
' . $_POST['addr2'] . '
' . $_POST['suburb'] . '
' . $_POST['city'] . '
' . $_POST['region'] . '
' . $_POST['postcode'] . '
' . $_POST['country'];
        }
    }
    
    include 'yak_view_' . $action . '.php';

}


/**
 * if all funds have been received for an order, and there is downloadable content,
 * send an email containing the link for the dl
 */
function yak_check_order($order_id) {
    global $wpdb, $order_table, $order_detail_table, $order_dl_table;
    
    $order = $wpdb->get_row("select o.funds_received, o.shipping_cost + sum(od.price * od.quantity) as total_cost, address from $order_table o, $order_detail_table od where o.id = $order_id and o.id = od.id group by o.id");
    
    $dl = $wpdb->get_row("select count(*) as total from $order_dl_table where order_id = $order_id and uid is not null");
    
    if ($order->funds_received >= $order->total_cost && $dl->total < 1) {
        $a1 = $order->funds_received;
        $a2 = $order->total_cost;
        $results = $wpdb->get_results("select * from $order_dl_table where order_id = $order_id"); 
        
        $dl_uri = yak_get_option(DOWNLOAD_URI, '');
        $msg = yak_get_option(DOWNLOAD_EMAIL, '');
        if ($dl_uri == '' || $msg == '') {
            return;
        }
                
        $uris = '';
        if ($results) {
            foreach ($results as $result) {
                $id = $result->id;
                $uid = md5(uniqid(rand(), true));
                
                $wpdb->query("update $order_dl_table set uid = '$uid' where id = $id");
                
                $uris = $uris . $dl_uri . '?uid=' . $uid . '
'; 
            }
            
            syslog(LOG_INFO, '>>>>>>>>>> uris = ' . $uris);
            
            // send email with download links
            if ($uris != '') {
                $fromEmail = yak_get_option(DOWNLOAD_EMAIL_ADDRESS, '');
                
                $split = split("\n", $order->address);
                $email = $split[1];
                
                $mail = sprintf($msg, $uris);

                wp_mail($email, __('Your purchased downloads', 'yak'), $mail, "From: " . $fromEmail);
    
                $mail = sprintf(__('The following email has been sent to %s :', 'yak'), $email) . "\r\n" . $mail;
                wp_mail($fromEmail, __('Purchased downloads', 'yak'), $mail, '');
            }
        }
    }
}


/**
 * remove order from the session
 */
function yak_cleanup_after_order() {
    unset($_SESSION['items']);
}


function yak_count_items($items) {
    if ($items == NULL) {
        return 0;
    }
    
    $count = 0;
    foreach ($items as $key => $value) {
        if (!empty($value)) {
            $count++;
        }
    }
    return $count;
}

/**
 * return a default if the specified value is not set
 */
function yak_default($val, $def) {
    if (yak_empty($val)) {
        return $def;   
    }
    else {
        return $val;   
    }
}


/**
 * return true if a value is empty
 */
function yak_empty($value) {
    return (!isset($value) || $value == null || $value == '');   
}


function yak_format_money($money, $include_symbol = true) {
    $sym = yak_get_option(CURRENCY_SYMBOL, '');
    $mformat = yak_get_option(MONEY_FORMAT, '');
    $cformat = yak_get_option(CURRENCY_FORMAT, '');
    
    $money = sprintf($mformat, $money);
    $money = number_format($money);
    if ($include_symbol) {
        return sprintf($cformat, $money, $sym);
    }
    else {
        return $money;
    }
}


/**
 * get the id from the GET or POST request data
 */
function yak_get_order_id($echo = true) {
    $order_id = $_GET['order_id'];
    if (yak_empty($order_id)) {
        $order_id = $_POST['order_id'];   
    }
    
    if ($echo) {
        echo $order_id;   
    }
    
    return $order_id;
}


function yak_get_option($name, $default) {
    $options = get_option(YAK_OPTIONS);
    $value = $options[$name];
    
    return yak_default($value, $default);
}

/**
 * return the value of an order (the value of each item plus the shipping cost)
 */ 
function yak_get_order_value($echo = true) {
    global $wpdb, $order_detail_table, $order_table;
    
    $rtn = 0;
    $order_id = yak_get_order_id(false);
    
    if (isset($order_id) && $order_id != '') {
        $r = $wpdb->get_row("select sum(od.price * od.quantity) as total, o.shipping_cost from $order_table o, $order_detail_table od where o.id = $order_id and od.id = $order_id group by o.id");
        $rtn = $r->total + $r->shipping_cost;
    }
    
    if ($echo) {
        echo yak_format_money($rtn, true);
    }
    return yak_format_money($rtn, true);
}


/**
 * 
 */
function yak_get_product_post() {
    global $post, $yak_post;
    
    // yak_post can be used to override `the_loop` post
    if (isset($yak_post)) {
        $pp = $yak_post;
    }
    else {
        $pp = $post;   
    }
    
    return $pp;
}


function yak_get_title($post_id) {
    $title = get_post_meta($post_id, 'yak_title', true);
    if (yak_empty($title)) {
        $post = get_post($post_id);
        $title = $post->post_title;
    }
    
    return $title;
}


function yak_get_url($url) {
    if (strpos($url, 'http://') === false && strpos($url, 'https://') === false) {
        $rtn = get_bloginfo('wpurl') . $url;
    }
    else {
        $rtn = $url;
    }
    
    return $rtn;
}

/**
 * javascript functions & stylesheet to be included in the head
 */
function yak_head() {
    echo '<link rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/j-yak/yak.css" type="text/css" media="screen" />';
}


/**
 * initialisation functions (exec'd before the rest of the page is rendered)
 */
function yak_init() {
    global $order_table, $order_detail_table, $order_dl_table, $wpdb, $payment_options;  // globals
    
    $email = '';
    if ($_POST['action'] == 'confirm2') {
        
        $caddress = unserialize(stripslashes($_COOKIE['shipping_address']));
        $addr = '';
        foreach ( $caddress as $key => $value ) {
            if (!empty($value)) {
                $addr = $addr . $value . "\n";
                
                if ($key == 'email') {
                    $email = $value;   
                }
            }
        }
        
        $items = $_SESSION['items'];
        
        // *************************************************************************
        // TODO: check if we have enough stock available...
        // *************************************************************************
        
        $not_enough_stock = false;
        
        
        if ($not_enough_stock) {
            $_POST['action'] = 'stockerror';
            return;
        }
        
        // END TODO ****************************************************************
                
        // now write the order to the database 
        
        $payment_type = array_search($_POST['payment_type'], $payment_options);
        
		$shipping_cost = '0';
		if (isset($_POST['shippingcost']) && trim($_POST['shipping_cost']) != '') {
			$shipping_cost = $_POST['shippingcost'];
		}
		
        $wpdb->query("insert into $order_table (time, address, shipping_cost, payment_type) values (current_timestamp(), '" . $addr . "', " . $shipping_cost . ", '" . $payment_type . "')");
        $order_id = $wpdb->insert_id;
    
        foreach ($items as $key => $item) {
            $item_name = yak_escape_string(yak_get_title($item->id));
            $price = yak_calc_price($item->id); 
            $current_quantity = get_post_meta($item->id, 'yak_quantity', true);
            
            
            $wpdb->query("insert into $order_detail_table (id, itemname, price, quantity) values ($order_id, '$item_name', $price, " . $item->quantity . ")");
            $newquantity = $current_quantity - $item->quantity;
            $newquantity = ($newquantity < 0 ? 0 : $newquantity);
            
            update_post_meta($key, 'yak_quantity', "$newquantity");
            
            $dl_file = get_post_meta($item->id, DOWNLOAD_FILE, true);
            
            if (isset($dl_file) && $dl_file != '') {
                $wpdb->query("insert into $order_dl_table (order_id, uid, dl_file, download_attempts) values ($order_id, null, '$dl_file', 0)");
            }
        }
     
        $url = call_user_func($_POST['payment_type'], $order_id, $items, $_POST['shippingcost_peritem']);
        
        wp_redirect($url);
        exit;
    }
    else if ($_POST['action'] == 'confirm' && count(yak_validate_address()) == 0) {
        // set the shipping address as a cookie for later reuse
        $caddress = array();
        $caddress['recipientname'] = $_POST['recipientname'];
        $caddress['email'] = $_POST['email'];
        $caddress['phone'] = $_POST['phone'];
        $caddress['addr1'] = $_POST['addr1'];
        $caddress['addr2'] = $_POST['addr2'];
        $caddress['suburb'] = $_POST['suburb'];
        $caddress['city'] = $_POST['city'];
        $caddress['region'] = $_POST['region'];
        $caddress['postcode'] = $_POST['postcode'];
        $caddress['country'] = $_POST['country'];
        $saddr = serialize($caddress);
        setcookie('shipping_address', $saddr, time()+yak_get_option(COOKIE_LIFETIME, 2592000));   
    }
    else if (isset($_POST['buynow'])) {
        // the buy button has been hit
        $items = NULL;
        if (isset($_SESSION['items'])) {
            $items = $_SESSION['items'];
        }
        else {
            $items = array();
            $_SESSION['items'] = $items;
        }
        
        $p = $_POST['buynow'];
        $param_name = $_POST['buynow_param'];
        
        if (!isset($items[$p]) || empty($items[$p])) {
            $items[$p] = new YakItem($param_name, $p, 1);
            
            $_SESSION['items'] = $items;  // probably not needed, but I had some weird problems earlier

            $GLOBALS['buynow_error_message'] = '<span class="yak_buyerror">' . __('This item has been added to your shopping cart', 'yak') . '</span>';
        }
        else {
            $GLOBALS['buynow_error_message'] = '<span class="yak_buyerror">' . __('This item is already in your shopping cart', 'yak') . '</span>';
        }

    }
    
}


function yak_html_multiselect($name, $selected, $values) {
    echo '<select name="' . $name . '[]" multiple="true">';
    
    foreach ($values as $key=>$value) {
        echo "  <option value=\"$key\"";
        
        if ((is_array($selected) && in_array($key, $selected)) ||
         $selected == $key) {
            echo " SELECTED";
        }
        echo ">$value</option>";
    }
    
    echo '</select>';
}

function yak_html_select($name, $selected, $values) {
    echo "<select name=\"$name\">";
    
    foreach ($values as $key=>$value) {
        echo "  <option value=\"$key\"";
        
        if ($selected == $key) {
            echo " SELECTED";
        }
        echo ">$value</option>";
    }
    
    echo "</select>";
}


/**
 * installation routine to set up tables
 */
function yak_install() {
    global $wpdb, $order_table, $order_detail_table, $order_log_table, $order_dl_table;
    if ($wpdb->get_var("show tables like '$order_table'") != $order_table) {
        $sql = "CREATE TABLE $order_table (
                id mediumint(9) primary key not null auto_increment,
                time timestamp(14) not null,
                address text not null,
                funds_received float default '0.0',
                stock_sent tinyint default '0' not null,
                shipping_cost float default '0.0',
                payment_type varchar(30)
                );";
        syslog(LOG_INFO, "creating table $order_table");
        dbDelta($sql);
    }
    
    if ($wpdb->get_var("show tables like '$order_detail_table'") != $order_detail_table) {
        $sql = "CREATE TABLE $order_detail_table (
                id mediumint(9) not null,
                itemname text not null,
                price float not null,
                quantity smallint default '1' not null
                );";
        syslog(LOG_INFO, "creating table $order_detail_table");
        dbDelta($sql);
    }
    
    if ($wpdb->get_var("show tables like '$order_log_table'") != $order_log_table) {
        $sql = "CREATE TABLE $order_log_table (
                time timestamp(14) not null,
                message text not null
                );";
        syslog(LOG_INFO, "creating table $order_log_table");
        dbDelta($sql);
    } 
    
    if ($wpdb->get_var("show tables like '$order_dl_table'") != $order_dl_table) {
        $sql = "CREATE TABLE $order_dl_table (
                id mediumint(9) primary key not null auto_increment,
                order_id mediumint(9) not null,
                uid text,
                dl_file text not null,
                download_attempts smallint,
                download_address text
                );";
        syslog(LOG_INFO, "creating table $order_log_table");
        dbDelta($sql);  
    }
    
}


function yak_escape_string($string) {
    if(version_compare(phpversion(),"4.3.0") == "-1") {
        return mysql_escape_string($string);
    }
    else {
        return mysql_real_escape_string($string);
    }
}


function yak_price($discount = true) {
    $pp = yak_get_product_post();
    
    if ($discount) {
        $price = yak_calc_price($pp->ID);
    }
    else {
        $price = get_post_meta($pp->ID, 'yak_price', true);   
    }
    
    echo yak_format_money($price);
}


/**
 * display a list of all products... not much use if you're aiming at Amazon-sized list of products, of course
 */
function yak_product_page() {
    global $yak_post;
    $ar = get_posts('showposts=-1&order=post_title&order=DESC&numberposts=-1');
    
    foreach ($ar as $post) {
        $price = get_post_meta($post->ID, 'yak_price', true);
        if (yak_empty($price)) {
            continue;   
        }

        $GLOBALS['yak_post'] = $post;
        echo '<div class="yak_product"><h3><a href="' . apply_filters('the_permalink', get_permalink($post->ID)) . '">' . $post->post_title . '</a></h3>';
        $content = explode('<!--more-->', $post->post_content, 2);
        echo apply_filters('the_content', $content[0]);
        echo '</div>';
    } 
   
}


/**
 * callback for the 'publish_post' event -- when a post is published, check if the auto-set options
 * have been set.  If so, automatically set the price and quantity
 */
function yak_publish_post($post_id) {
    $price = get_post_meta($post_id, 'yak_price', true);
    $qty = get_post_meta($post_id, 'yak_quantity', true);
    
    $default_price = yak_get_option(AUTO_SET_PRICE, '');
    $default_qty = yak_get_option(AUTO_SET_QUANTITY, '');
    
    if (yak_empty($price) && isset($default_price)) {
        yak_add_meta($post_id, 'yak_price', "$default_price");
        syslog(LOG_INFO, "update default price $default_price"); 
    }
    
    if (yak_empty($qty) && isset($default_qty)) {
        yak_add_meta($post_id, 'yak_quantity', "$default_qty");
        syslog(LOG_INFO, "update default qty $default_qty");
    }
    
}


/**
 * get the quantity of stock available for the current product
 */
function yak_quantity() {
    $pp = yak_get_product_post();
    
    echo get_post_meta($pp->ID, 'yak_quantity', true);    
}


function yak_validate_address() {
    global $required_address_fields;
    
    $missing = array();
    
    foreach ($required_address_fields as $field => $message) {
        if (yak_empty($_POST[$field])) {
            $missing[] = $message;
        }
    }
    return $missing;
}


/**
 * countries list
 */
$countries = array();

//Hokkaido
$countries["Hokkaido"]   = __("Hokkaido", "yak");

//KitaTouhoku
$countries["Aomori"]     = __("Aomori", "yak");
$countries["Akita"]      = __("Akita", "yak");
$countries["Iwate"]      = __("Iwate", "yak");

//MinamiTouhoku
$countries["Miyagi"]     = __("Miyagi", "yak");
$countries["Yamagata"]   = __("Yamagata", "yak");
$countries["Fukushima"]  = __("Fukushima", "yak");

//Kanto
$countries["Ibaragi"]    = __("Ibaragi", "yak");
$countries["Tochigi"]    = __("Tochigi", "yak");
$countries["Gunma"]      = __("Gunma", "yak");
$countries["Saitama"]    = __("Saitama", "yak");
$countries["Chiba"]      = __("Chiba", "yak");
$countries["Tokyo"]      = __("Tokyo", "yak");
$countries["Kanagawa"]   = __("Kanagawa", "yak");
$countries["Yamanashi"]  = __("Yamanashi", "yak");

//ShinEtsu
$countries["Nagano"]     = __("Nagano", "yak");
$countries["Nigata"]     = __("Nigata", "yak");

//Hokuriku
$countries["Toyama"]     = __("Toyama", "yak");
$countries["Ishikawa"]   = __("Ishikawa", "yak");
$countries["Fukui"]      = __("Fukui", "yak");

//Cyubu
$countries["Shizuoka"]   = __("Shizuoka", "yak");
$countries["Aichi"]      = __("Aichi", "yak");
$countries["Gifu"]       = __("Gifu", "yak");
$countries["Mie"]        = __("Mie", "yak");

//Kansai
$countries["Kyoto"]      = __("Kyoto", "yak");
$countries["Shiga"]      = __("Shiga", "yak");
$countries["Nara"]       = __("Nara", "yak");
$countries["Wakayama"]   = __("Wakayama", "yak");
$countries["Osaka"]      = __("Osaka", "yak");
$countries["Hyogo"]      = __("Hyogo", "yak");

//Cyugoku
$countries["Okayama"]    = __("Okayama", "yak");
$countries["Hiroshima"]  = __("Hiroshima", "yak");
$countries["Yamaguchi"]  = __("Yamaguchi", "yak");
$countries["Tottori"]    = __("Tottori", "yak");
$countries["Shimane"]    = __("Shimane", "yak");

//Shikoku
$countries["Kagawa"]     = __("Kagawa", "yak");
$countries["Tokushima"]  = __("Tokushima", "yak");
$countries["Kochi"]      = __("Kochi", "yak");
$countries["Ehime"]      = __("Ehime", "yak");

//Kyusyu
$countries["Fukuoka"]    = __("Fukuoka", "yak");
$countries["Saga"]       = __("Saga", "yak");
$countries["Nagasaki"]   = __("Nagasaki", "yak");
$countries["Kumamoto"]   = __("Kumamoto", "yak");
$countries["Oita"]       = __("Oita", "yak");
$countries["Miyazaki"]   = __("Miyazaki", "yak");
$countries["Kagoshima"]  = __("Kagoshima", "yak");

//Okinawa
$countries["Okinawa"]    = __("Okinawa", "yak");

/**
 * wordpress actions
 */
add_action('init', 'yak_init');
add_action('admin_head', 'yak_head');
add_action('wp_head', 'yak_head');
add_action('activate_yak','yak_install');
add_action('admin_menu', 'yak_admin');
add_action('publish_post', 'yak_publish_post');

?>
