<?php
/*
See yak.php for information and license terms
*/

require_once(ABSPATH . 'wp-includes/wp-l10n.php');

global $model;
global $payment_options;

$selected_payment_options = yak_get_option(PAYMENT_OPTIONS, array());

$shipping_notes = yak_get_option(SHIPPING_NOTES, '');
?>

<h3><?php _e('Confirm your order', 'yak'); ?></h3>

<p><?php _e('Shipping address', 'yak'); ?>:</p>

<p class="yak_small">
<?php
foreach ( split("\n", $model['shipping_address']) as $val) {
    if (!empty($val)) {
        echo $val . '<br />';   
    }
}
?>
</p>
        
<p>&nbsp;</p>

<h3><?php _e('Order Detail', 'yak'); ?></h3>

<form name="confirm2" method="post" action="<?php echo $_SERVER[PHP_SELF]; ?>">
    <table class="yak_order">
        <tr>
            <th><?php _e('Title', 'yak'); ?></th>
            <th class="yak_numeric"><?php _e('Price', 'yak'); ?></th>
            <th class="yak_numeric"><?php _e('Qty', 'yak'); ?></th>
            <th class="yak_numeric"><?php _e('Subtotal', 'yak'); ?></th>
        </tr>
        
<?php
    $total_price = 0;
    $total_quantity = 0;
    foreach ($model['items'] as $key => $item) {
        $price = yak_calc_price($item->id);
        $total_price += ($price * $item->quantity);
        $item_price = $price * $item->quantity;
        $total_quantity += $item->quantity;
?>
        <tr>
            <td><?php echo yak_get_title($item->id); ?></td>
            <td class="yak_numeric"><?php echo yak_format_money($price); ?></td>
            <td class="yak_numeric"><?php echo $item->quantity; ?></td>
            <td class="yak_numeric"><?php echo yak_format_money($item_price); ?></td>
        </tr>
<?php
    }
    
    if (yak_get_option(INCLUDE_SHIPPING_COSTS, 'no') == 'yes') {
        global $shipping_costs;
        $shipping_cost = yak_get_option('yak_' . $_POST['country'] . '_shipping', '');
        if (!isset($shipping_cost) || $shipping_cost == '') {
            $shipping_cost = yak_get_option('yak_default_shipping', '');
        }
        //$act_shipping_cost = $shipping_cost * $total_quantity;
	$act_shipping_cost = $shipping_cost;
        
        $total_price += $act_shipping_cost;
?>

        <tr id="yak_shipping">
            <td><?php _e('Shipping costs', 'yak'); ?></td>
            <td></td>
            <td></td>
            <td class="yak_numeric"><?php echo yak_format_money($act_shipping_cost); ?></td>
        </tr>
<?php
        if ($shipping_notes != '') {
?>
        <tr>
            <td class="yak_small"><?php echo $shipping_notes; ?></td>
            <td colspan="3"></td>
        </tr>
<?php
        }
    }
?>
    
        <tr>
            <td class="yak_total" colspan="3"><?php _e('Total', 'yak'); ?></td>
            <td class="yak_total"><?php echo yak_format_money($total_price); ?></td>
        </tr>
    
<?php
    if (count($selected_payment_options) > 1) {
?>
        <tr>
            <td><?php _e('Payment method', 'yak'); ?></td>
            <td colspan="3" align="right">
                <select name="payment_type">
<?php
        foreach ( $payment_options as $key => $value ) {
            if (!in_array($value, $selected_payment_options)) {
                continue;
            }
?>
                    <option value="<?php echo $value; ?>"><?php echo $key; ?></option>
<?php
        }
?>
                </select></td>
        </tr>

<?php
    }
?>
    
        <tr>
            <td colspan="4"><input type="image" src="<?php echo CONFIRM_ORDER_BUTTON_IMAGE; ?>" /></td>
        </tr>
    </table>
    <input type="hidden" name="totalprice" value="<?php echo $total_price; ?>" />
    <input type="hidden" name="shippingcost" value="<?php echo $act_shipping_cost; ?>" />
    <input type="hidden" name="shippingcost_peritem" value="<?php echo $shipping_cost; ?>" />
    <input type="hidden" name="action" value="confirm2" />
    <input type="hidden" name="<?php echo $model['param_name']; ?>" value="<?php echo $model['post_id']; ?>" />

<?php
    if (count($selected_payment_options) == 1) {
        
?>
    <input type="hidden" name="payment_type" value="<?php echo $selected_payment_options[0]; ?>" />

<?php
    }
?>

</form>
