<?php
/*
See yak.php for information and license terms
*/

require_once(ABSPATH . 'wp-includes/wp-l10n.php');

global $model, $payment_options, $payment_url_examples, $countries;

$yamato_url = '<a href="http://partner.kuronekoyamato.co.jp/estimate/tak_est.html">http://partner.kuronekoyamato.co.jp/estimate/tak_est.html</a>';
?>

<div class="wrap">
    <form method="post">
        <h2><?php _e('YAK Options', 'yak') ?></h2>

	<fieldset class="options">
		<legend><?php _e('Basic Settings', 'yak') ?></legend>
        <table class="yak_options">
            <tr>
                <th><?php _e('Quantity Input Size', 'yak') ?></th>
                <td><input type="text" name="<?php echo QUANTITY_INPUT_SIZE; ?>" value="<?php echo $model[QUANTITY_INPUT_SIZE]; ?>" /></td>
                <td><?php _e('Number of digits allowed in input box', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Cookie Lifetime (days)', 'yak') ?></th>
                <td><input type="text" name="<?php echo COOKIE_LIFETIME; ?>" value="<?php echo $model[COOKIE_LIFETIME]; ?>" /></td>
                <td></td>
            </tr>
            <tr>
                <th><?php _e('Include Shipping Costs', 'yak') ?></th>
                <td><?php yak_html_select(INCLUDE_SHIPPING_COSTS, $model[INCLUDE_SHIPPING_COSTS], array('yes'=>__('Yes', 'yak'), 'no'=>__('No', 'yak'))); ?></td>
                <td></td>
            </tr>
            <tr>
                <th><?php _e('Currency Symbol', 'yak') ?></th>
                <td><input type="text" name="<?php echo CURRENCY_SYMBOL; ?>" value="<?php echo $model[CURRENCY_SYMBOL]; ?>" /></td>
                <td></td>
            </tr>
            <tr>
                <th><?php _e('Money Format', 'yak') ?></th>
                <td><input type="text" name="<?php echo MONEY_FORMAT; ?>" value="<?php echo $model[MONEY_FORMAT]; ?>" /></td>
                <td></td>
            </tr>
            <tr>
                <th><?php _e('Currency Format', 'yak') ?></th>
                <td><input type="text" name="<?php echo CURRENCY_FORMAT; ?>" value="<?php echo $model[CURRENCY_FORMAT]; ?>" /></td>
                <td></td>
            </tr>
<!--
            <tr>
                <th><?php _e('Default Country', 'yak') ?></th>
                <td><?php yak_html_select(DEFAULT_COUNTRY, $model[DEFAULT_COUNTRY], $countries); ?></td>
                <td></td>
            </tr>
-->
            <tr>
                <th><?php _e('Show "Out of Stock"', 'yak') ?></th>
                <td><?php yak_html_select(SHOW_OUT_OF_STOCK_MSG, $model[SHOW_OUT_OF_STOCK_MSG], array('yes'=>__('Yes', 'yak'), 'no'=>__('No', 'yak'))); ?></td>
                <td></td>
            </tr>
            <tr>
                <th><?php _e('Confirmation Email', 'yak') ?></th>
                <td><input type="text" name="<?php echo CONFIRMATION_EMAIL_ADDRESS; ?>" value="<?php echo $model[CONFIRMATION_EMAIL_ADDRESS]; ?>" /></td>
                <td><?php _e('Leave blank to not send confirmation', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Confirmation Message', 'yak') ?></th>
                <td colspan="2"><textarea cols="40" rows="4" name="<?php echo CONFIRMATION_MESSAGE; ?>"><?php echo $model[CONFIRMATION_MESSAGE]; ?></textarea>
<br /><?php _e('Note:', 'yak') ?>
		<?php _e('%1$s is the order number', 'yak') ?>
                <?php _e('%2$s is the order detail', 'yak') ?>
                <?php _e('%3$s is the total order cost', 'yak') ?>
                <?php _e('%4$s is the payment type', 'yak') ?></td>
            </tr>
            <tr>
                <th><?php _e('Redirect on buy to', 'yak') ?></th>
                <td><input type="text" name="<?php echo REDIRECT_ON_BUY_TO; ?>" value="<?php echo $model[REDIRECT_ON_BUY_TO]; ?>" /></td>
                <td><?php _e('Enter page or post id, or leave blank', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Auto discount', 'yak') ?></th>
                <td><input type="text" name="<?php echo AUTO_DISCOUNT; ?>" value="<?php echo $model[AUTO_DISCOUNT]; ?>" /></td>
                <td><?php _e('A fraction -- or 1 for no discount', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Price rounding', 'yak') ?></th>
                <td><input type="text" name="<?php echo PRICE_ROUNDING; ?>" value="<?php echo $model[PRICE_ROUNDING]; ?>" /></td>
                <td><?php _e('The number of decimal places to round to', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Require Phone Number', 'yak') ?></th>
                <td><input type="checkbox" name="<?php echo REQUIRE_PHONE_NUMBER; ?>" <?php if ($model[REQUIRE_PHONE_NUMBER] == 'on') { echo 'CHECKED'; } ?> /></td>
                <td><?php _e('Is a phone number required (as well as address)?', 'yak'); ?></td>
            </tr>
        </table>
	</fieldset>

	<fieldset class="options">
		<legend><?php _e('Automatic setup of products', 'yak') ?></legend>
        <table class="yak_options">
            <tr>
                <th><?php _e('Auto price', 'yak') ?></th>
                <td><input type="text" name="<?php echo AUTO_SET_PRICE; ?>" value="<?php echo $model[AUTO_SET_PRICE] ?>" /></td>
                <td><?php _e('All new posts get this price (leave blank, if you don\'t want the price automatically set', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Auto quantity', 'yak') ?></th>
                <td><input type="text" name="<?php echo AUTO_SET_QUANTITY; ?>" value="<?php echo $model[AUTO_SET_QUANTITY] ?>" /></td>
                <td><?php _e('All new posts get this quantity', 'yak'); ?></td>
            </tr>
        </table>
	</fieldset>

	<fieldset class="options">
		<legend><?php _e('Download settings', 'yak') ?></legend>
        <table class="yak_options">
            <tr>
                <th><?php _e('Download uri', 'yak') ?></th>
                <td><input type="text" name="<?php echo DOWNLOAD_URI; ?>" value="<?php echo $model[DOWNLOAD_URI] ?>" /></td>
                <td><?php printf(__('The uri of the yak_dl.php file (e.g. %s/wp-content/plugins/j-yak/yak_dl.php)', 'yak'), get_bloginfo('wpurl')); ?></td>
            </tr>
            <tr>
                <th><?php _e('Download Email', 'yak') ?></th>
                <td colspan="2"><textarea cols="40" rows="4" name="<?php echo DOWNLOAD_EMAIL; ?>"><?php echo $model[DOWNLOAD_EMAIL] ?></textarea>
<br /><?php _e('A message containing a list of download uris for purchased products (%1$s is the uri list)', 'yak'); ?></td>
            </tr>
            <tr>
                <th><?php _e('Download Email address', 'yak') ?></th>
                <td><input type="text" name="<?php echo DOWNLOAD_EMAIL_ADDRESS; ?>" value="<?php echo $model[DOWNLOAD_EMAIL_ADDRESS] ?>" /></td>
                <td><?php _e('Email address from which download messages are sent', 'yak'); ?></td>
            </tr>
        </table>
	</fieldset>

	<fieldset class="options">
		<legend><?php _e('Payment Settings', 'yak') ?></legend>
        <table class="yak_options">
            <tr>
                <td colspan="3"><h4><?php _e('Redirect URLs for Payment', 'yak') ?></h4></td>
            </tr>
            <?php foreach ($payment_options as $key=>$value) { ?>
            <tr>
                <th><?php echo $key; ?></th>
                <td><input type="text" name="<?php echo $value . '_url'; ?>" value="<?php echo $model[$value . '_url']; ?>" /></td>
                <td><?php echo __('e.g. ','yak') . $payment_url_examples[$key] ?></td>
            </tr>
            <?php } ?>
            <tr>
                <td colspan="3"><h4><?php _e('Paypal settings', 'yak') ?></h4></td>
            </tr>
            <tr>
                <th><?php _e('Account', 'yak') ?></th>
                <td><input type="text" name="<?php echo PAYPAL_ACCOUNT; ?>" value="<?php echo $model[PAYPAL_ACCOUNT]; ?>" /></td>
                <td><?php _e('Usually your email address', 'yak') ?></td>
            </tr>
            <tr>
                <th><?php _e('Return url', 'yak') ?></th>
                <td><input type="text" name="<?php echo PAYPAL_RETURN_URL; ?>" value="<?php echo $model[PAYPAL_RETURN_URL]; ?>" /></td>
                <td><?php _e('e.g.', 'yak') ?> ?page_id=19</td>
            </tr>
            <tr>
                <th><?php _e('Cancel return url', 'yak') ?></th>
                <td><input type="text" name="<?php echo PAYPAL_CANCEL_RETURN_URL; ?>" value="<?php echo $model[PAYPAL_CANCEL_RETURN_URL]; ?>" /></td>
                <td><?php _e('e.g.', 'yak') ?> ?page_id=14</td>
            </tr>
            <tr>
                <th><?php _e('Identity token', 'yak') ?></th>
                <td><input type="text" name="<?php echo PAYPAL_IDENTITY_TOKEN; ?>" value="<?php echo $model[PAYPAL_IDENTITY_TOKEN]; ?>" /></td>
                <td></td>
            </tr>
			<tr>
				<th><?php _e('Currency code', 'yak') ?></th>
				<td><input type="text" name="<?php echo PAYPAL_CURRENCY_CODE; ?>" value="<?php echo $model[PAYPAL_CURRENCY_CODE]; ?>" /></td>
                <td><?php _e('e.g. AUD, CAD, EUR, GBP, JPY or USD', 'yak') ?></td>
			</tr>
        </table>

        <div class="submit">
            <input type="submit" name="options_update" value="<?php _e('Update options', 'yak') ?>" />
        </div>
        
        <table class="yak_options">
            <tr>
                <td colspan="2"><h4><?php _e('Shipping costs', 'yak') ?></h4></td>
            </tr>
            <tr>
                <td colspan="2"><?php printf(__('Yamato', 'yak'), $yamato_url); ?></td>
            </tr>
            <tr>
                <th><?php _e('Default shipping', 'yak'); ?></th>
                <td><input type="text" name="<?php echo DEFAULT_SHIPPING; ?>" value="<?php echo $model[DEFAULT_SHIPPING]; ?>" /></td>
            </tr>
            <tr>
                <th><?php _e('Shipping Notes', 'yak'); ?></th>
                <td><textarea cols="40" rows="2" name="<?php echo SHIPPING_NOTES; ?>"><?php echo $model[SHIPPING_NOTES]; ?></textarea></td>
            </tr>
            <?php foreach ($countries as $country=>$ignore) {
                ?>
            <tr>
                <th><?php echo $ignore; ?></th>
                <td><input type="text" name="<?php echo 'yak_' . str_replace(' ', '_', $country) . '_shipping'; ?>" value="<?php echo $model['yak_' . str_replace(' ', '_', $country) . '_shipping']; ?>" /></td>
            </tr>
            <?php } ?>
        </table>
	</fieldset>
            
        <div class="submit">
            <input type="submit" name="options_update" value="<?php _e('Update options', 'yak') ?>" />
        </div>
    </form>
</div>
