<?php
/*
Plugin Name: wp-idnhack
Plugin URI: http://wppluginsj.sourceforge.jp/wp-idnhack/
Description: don't think. feel the IDN.
Author: hiromasa
Version: 0.1
Author URI: http://hiromasa.zone.ne.jp/blog/
*/

/*  Copyright 2006 hiromasa  (email : webmaster@hiromasa.zone.ne.jp)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/******************************************************************************
 * WpIDNhack
 * 
 * @author		hiromasa
 * @version		0.1
 * 
 *****************************************************************************/

function clean_url_IDNhack( $url ) {
	
	if ('' == $url) return $url;
	$url = wp_specialchars($url);
	$strip = array('%0d', '%0a');
	$url = str_replace($strip, '', $url);
	$url = str_replace(';//', '://', $url);
	$url = (!strstr($url, '://')) ? 'http://'.$url : $url;
	$url = preg_replace('/&([^#])(?![a-z]{2,8};)/', '&#038;$1', $url);
	
	return $url;
	
}

/******************************************************************************
 * WpIDNhack - WordPress Interface Define
 *****************************************************************************/

remove_filter('pre_comment_author_url', 'clean_url');
remove_filter('comment_url', 'clean_url');
remove_filter('pre_link_url', 'clean_url');
remove_filter('pre_link_image', 'clean_url');
remove_filter('pre_link_rss', 'clean_url');
remove_filter('pre_user_url', 'clean_url');

add_filter('pre_comment_author_url', 'clean_url_IDNhack');
add_filter('comment_url', 'clean_url_IDNhack');
add_filter('pre_link_url', 'clean_url_IDNhack');
add_filter('pre_link_image', 'clean_url_IDNhack');
add_filter('pre_link_rss', 'clean_url_IDNhack');
add_filter('pre_user_url', 'clean_url_IDNhack');

?>