<?php
/*
Plugin Name: wp-murasame
Plugin URI: http://hiromasa.zone.ne.jp/blog/archives/934/
Description: 日本語に対応したさまざまな抜粋表現を提供します。
Author: hiromasa
Version: 0.40
Author URI: http://hiromasa.zone.ne.jp/blog/
Special Thanks: ぼの (http://bono.s201.xrea.com/)
**/

/*  Copyright 2007 hiromasa  (email : webmaster@hiromasa.zone.ne.jp)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/******************************************************************************
 * WpMurasame - 設定
 *****************************************************************************/

define ("MURASAME_COMMA_COUNT", 3);

/******************************************************************************
 * WpMurasame
 * 
 * @author		hiromasa
 * @version		0.40
 * 
 *****************************************************************************/
class WpMurasame {
	
	/**
	 * WordPress Interface
	 * 
	 * @param $content
	 * @return $result
	 */
	function excerptComma($content) {
		
		$excerpt = new MultiByteExcerptComma($content);
		$excerpt->doExcerpt(MURASAME_COMMA_COUNT);
		$result = $excerpt->getContent();
		
		$result  = '<p>' . $result . '</p>' . "\n";
		$result .= '<p><a href="' . get_permalink() .'">' .
			'[続きを読む]' . '</a></p>';
		
		return $result;
		
	}
	
}

/******************************************************************************
 * MultiByteExcerptComma
 * 
 * @author		hiromasa
 * @version		0.40
 * 
 *****************************************************************************/
class MultiByteExcerptComma extends MultiByteExcerpt {
	
	/**
	 * doExcerpt
	 * 
	 * @param $args
	 * @return $content
	 */
	function doExcerpt($comma = 2) {
		
		$count = 0;
		for($pos = 0; $pos < mb_strlen($this->content); $pos++) {
			$pos = mb_strpos($this->content, "。", $pos);
			if($pos != false) {
				$count++;
			} else {
				break;
			}
			if($count >= $comma) break;
		}
		
		if($pos != false) {
			$result = mb_substr($this->content, 0, $pos + 1);
		} else {
			$result = $this->content;
		}
		
		$this->content = $result;
		
	}
	
}

/******************************************************************************
 * MultiByteExcerpt
 * 
 * @author		hiromasa
 * @version		0.40
 * 
 *****************************************************************************/
class MultiByteExcerpt {
	
	var $content;
	
	/**
	 * The Constructor
	 * 
	 * @param none
	 * @return none
	 */
	function MultiByteExcerpt($content) {
		
		$this->content = strip_tags($content);
		
	}
	
	/**
	 * getContent
	 * 
	 * @param none
	 * @return $this->content
	 */
	function getContent() {
		
		return $this->content;
		
	}
	
}

/******************************************************************************
 * WpMurasame - WordPress Interface Define
 *****************************************************************************/

$wpMurasame = & new WpMurasame();

// RSS 出力時の抜粋
add_filter('the_excerpt_rss', array(&$wpMurasame, 'excerptComma'));
// 検索結果等 the_excerpt で出力される抜粋
//add_filter('the_excerpt', array(&$wpMurasame, 'excerptComma'));
// トラックバック受信時の抜粋です
//add_filter('comment_excerpt', array(&$wpMurasame, 'excerptComma'));
?>
